# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev6
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class AccountToAccountTransferRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    A request to transfer funds from one account to another
    """


    class MetaOapg:
        required = {
            "amount",
            "currency",
        }
        
        class properties:
            
            
            class amount(
                schemas.Int64Schema
            ):
            
            
                class MetaOapg:
                    format = 'int64'
                    inclusive_minimum = 0
            currency = schemas.StrSchema
            description = schemas.StrSchema
            dest_account_alias = schemas.StrSchema
            dest_account_id = schemas.StrSchema
            dest_account_no = schemas.StrSchema
            effective_date = schemas.DateTimeSchema
            
            
            class external_data(
                schemas.DictBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneFrozenDictMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
                ) -> 'external_data':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                        **kwargs,
                    )
            memo = schemas.StrSchema
            offset_description = schemas.StrSchema
            
            
            class posted_date(
                schemas.DateSchema
            ):
            
            
                class MetaOapg:
                    format = 'date'
                    regex=[{
                        'pattern': r'([0-9]{4})-(?:[0-9]{2})-([0-9]{2})',  # noqa: E501
                    }]
            source_account_alias = schemas.StrSchema
            source_account_id = schemas.StrSchema
            source_account_no = schemas.StrSchema
            subtype = schemas.StrSchema
            type = schemas.StrSchema
            
            
            class user_data(
                schemas.DictBase,
                schemas.NoneBase,
                schemas.Schema,
                schemas.NoneFrozenDictMixin
            ):
            
            
                def __new__(
                    cls,
                    *_args: typing.Union[dict, frozendict.frozendict, None, ],
                    _configuration: typing.Optional[schemas.Configuration] = None,
                    **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
                ) -> 'user_data':
                    return super().__new__(
                        cls,
                        *_args,
                        _configuration=_configuration,
                        **kwargs,
                    )
            uuid = schemas.UUIDSchema
            __annotations__ = {
                "amount": amount,
                "currency": currency,
                "description": description,
                "dest_account_alias": dest_account_alias,
                "dest_account_id": dest_account_id,
                "dest_account_no": dest_account_no,
                "effective_date": effective_date,
                "external_data": external_data,
                "memo": memo,
                "offset_description": offset_description,
                "posted_date": posted_date,
                "source_account_alias": source_account_alias,
                "source_account_id": source_account_id,
                "source_account_no": source_account_no,
                "subtype": subtype,
                "type": type,
                "user_data": user_data,
                "uuid": uuid,
            }
    
    amount: MetaOapg.properties.amount
    currency: MetaOapg.properties.currency
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["currency"]) -> MetaOapg.properties.currency: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dest_account_alias"]) -> MetaOapg.properties.dest_account_alias: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dest_account_id"]) -> MetaOapg.properties.dest_account_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["dest_account_no"]) -> MetaOapg.properties.dest_account_no: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["effective_date"]) -> MetaOapg.properties.effective_date: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["external_data"]) -> MetaOapg.properties.external_data: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["memo"]) -> MetaOapg.properties.memo: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["offset_description"]) -> MetaOapg.properties.offset_description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["posted_date"]) -> MetaOapg.properties.posted_date: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["source_account_alias"]) -> MetaOapg.properties.source_account_alias: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["source_account_id"]) -> MetaOapg.properties.source_account_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["source_account_no"]) -> MetaOapg.properties.source_account_no: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["subtype"]) -> MetaOapg.properties.subtype: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["type"]) -> MetaOapg.properties.type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["user_data"]) -> MetaOapg.properties.user_data: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["uuid"]) -> MetaOapg.properties.uuid: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["amount", "currency", "description", "dest_account_alias", "dest_account_id", "dest_account_no", "effective_date", "external_data", "memo", "offset_description", "posted_date", "source_account_alias", "source_account_id", "source_account_no", "subtype", "type", "user_data", "uuid", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["currency"]) -> MetaOapg.properties.currency: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dest_account_alias"]) -> typing.Union[MetaOapg.properties.dest_account_alias, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dest_account_id"]) -> typing.Union[MetaOapg.properties.dest_account_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["dest_account_no"]) -> typing.Union[MetaOapg.properties.dest_account_no, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["effective_date"]) -> typing.Union[MetaOapg.properties.effective_date, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["external_data"]) -> typing.Union[MetaOapg.properties.external_data, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["memo"]) -> typing.Union[MetaOapg.properties.memo, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["offset_description"]) -> typing.Union[MetaOapg.properties.offset_description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["posted_date"]) -> typing.Union[MetaOapg.properties.posted_date, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["source_account_alias"]) -> typing.Union[MetaOapg.properties.source_account_alias, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["source_account_id"]) -> typing.Union[MetaOapg.properties.source_account_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["source_account_no"]) -> typing.Union[MetaOapg.properties.source_account_no, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["subtype"]) -> typing.Union[MetaOapg.properties.subtype, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["type"]) -> typing.Union[MetaOapg.properties.type, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["user_data"]) -> typing.Union[MetaOapg.properties.user_data, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["uuid"]) -> typing.Union[MetaOapg.properties.uuid, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["amount", "currency", "description", "dest_account_alias", "dest_account_id", "dest_account_no", "effective_date", "external_data", "memo", "offset_description", "posted_date", "source_account_alias", "source_account_id", "source_account_no", "subtype", "type", "user_data", "uuid", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        amount: typing.Union[MetaOapg.properties.amount, decimal.Decimal, int, ],
        currency: typing.Union[MetaOapg.properties.currency, str, ],
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        dest_account_alias: typing.Union[MetaOapg.properties.dest_account_alias, str, schemas.Unset] = schemas.unset,
        dest_account_id: typing.Union[MetaOapg.properties.dest_account_id, str, schemas.Unset] = schemas.unset,
        dest_account_no: typing.Union[MetaOapg.properties.dest_account_no, str, schemas.Unset] = schemas.unset,
        effective_date: typing.Union[MetaOapg.properties.effective_date, str, datetime, schemas.Unset] = schemas.unset,
        external_data: typing.Union[MetaOapg.properties.external_data, dict, frozendict.frozendict, None, schemas.Unset] = schemas.unset,
        memo: typing.Union[MetaOapg.properties.memo, str, schemas.Unset] = schemas.unset,
        offset_description: typing.Union[MetaOapg.properties.offset_description, str, schemas.Unset] = schemas.unset,
        posted_date: typing.Union[MetaOapg.properties.posted_date, str, date, schemas.Unset] = schemas.unset,
        source_account_alias: typing.Union[MetaOapg.properties.source_account_alias, str, schemas.Unset] = schemas.unset,
        source_account_id: typing.Union[MetaOapg.properties.source_account_id, str, schemas.Unset] = schemas.unset,
        source_account_no: typing.Union[MetaOapg.properties.source_account_no, str, schemas.Unset] = schemas.unset,
        subtype: typing.Union[MetaOapg.properties.subtype, str, schemas.Unset] = schemas.unset,
        type: typing.Union[MetaOapg.properties.type, str, schemas.Unset] = schemas.unset,
        user_data: typing.Union[MetaOapg.properties.user_data, dict, frozendict.frozendict, None, schemas.Unset] = schemas.unset,
        uuid: typing.Union[MetaOapg.properties.uuid, str, uuid.UUID, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'AccountToAccountTransferRequest':
        return super().__new__(
            cls,
            *_args,
            amount=amount,
            currency=currency,
            description=description,
            dest_account_alias=dest_account_alias,
            dest_account_id=dest_account_id,
            dest_account_no=dest_account_no,
            effective_date=effective_date,
            external_data=external_data,
            memo=memo,
            offset_description=offset_description,
            posted_date=posted_date,
            source_account_alias=source_account_alias,
            source_account_id=source_account_id,
            source_account_no=source_account_no,
            subtype=subtype,
            type=type,
            user_data=user_data,
            uuid=uuid,
            _configuration=_configuration,
            **kwargs,
        )
