# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev6
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class AchTransactionData(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Transaction metadata specific to transactions with type `ACH`
    """


    class MetaOapg:
        required = {
            "id",
        }
        
        class properties:
            id = schemas.StrSchema
            description = schemas.StrSchema
            file_name = schemas.StrSchema
            originating_account_id = schemas.UUIDSchema
            originator_name = schemas.StrSchema
            receiving_account_id = schemas.UUIDSchema
            recipient_name = schemas.StrSchema
            return_code = schemas.StrSchema
            trace_number = schemas.StrSchema
            __annotations__ = {
                "id": id,
                "description": description,
                "file_name": file_name,
                "originating_account_id": originating_account_id,
                "originator_name": originator_name,
                "receiving_account_id": receiving_account_id,
                "recipient_name": recipient_name,
                "return_code": return_code,
                "trace_number": trace_number,
            }
    
    id: MetaOapg.properties.id
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["description"]) -> MetaOapg.properties.description: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["file_name"]) -> MetaOapg.properties.file_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originating_account_id"]) -> MetaOapg.properties.originating_account_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["originator_name"]) -> MetaOapg.properties.originator_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["receiving_account_id"]) -> MetaOapg.properties.receiving_account_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["recipient_name"]) -> MetaOapg.properties.recipient_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["return_code"]) -> MetaOapg.properties.return_code: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["trace_number"]) -> MetaOapg.properties.trace_number: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["id", "description", "file_name", "originating_account_id", "originator_name", "receiving_account_id", "recipient_name", "return_code", "trace_number", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["description"]) -> typing.Union[MetaOapg.properties.description, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["file_name"]) -> typing.Union[MetaOapg.properties.file_name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originating_account_id"]) -> typing.Union[MetaOapg.properties.originating_account_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["originator_name"]) -> typing.Union[MetaOapg.properties.originator_name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["receiving_account_id"]) -> typing.Union[MetaOapg.properties.receiving_account_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["recipient_name"]) -> typing.Union[MetaOapg.properties.recipient_name, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["return_code"]) -> typing.Union[MetaOapg.properties.return_code, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["trace_number"]) -> typing.Union[MetaOapg.properties.trace_number, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["id", "description", "file_name", "originating_account_id", "originator_name", "receiving_account_id", "recipient_name", "return_code", "trace_number", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        id: typing.Union[MetaOapg.properties.id, str, ],
        description: typing.Union[MetaOapg.properties.description, str, schemas.Unset] = schemas.unset,
        file_name: typing.Union[MetaOapg.properties.file_name, str, schemas.Unset] = schemas.unset,
        originating_account_id: typing.Union[MetaOapg.properties.originating_account_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        originator_name: typing.Union[MetaOapg.properties.originator_name, str, schemas.Unset] = schemas.unset,
        receiving_account_id: typing.Union[MetaOapg.properties.receiving_account_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        recipient_name: typing.Union[MetaOapg.properties.recipient_name, str, schemas.Unset] = schemas.unset,
        return_code: typing.Union[MetaOapg.properties.return_code, str, schemas.Unset] = schemas.unset,
        trace_number: typing.Union[MetaOapg.properties.trace_number, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'AchTransactionData':
        return super().__new__(
            cls,
            *_args,
            id=id,
            description=description,
            file_name=file_name,
            originating_account_id=originating_account_id,
            originator_name=originator_name,
            receiving_account_id=receiving_account_id,
            recipient_name=recipient_name,
            return_code=return_code,
            trace_number=trace_number,
            _configuration=_configuration,
            **kwargs,
        )
