# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.45.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class AdhocVerificationRequest(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Basic identifying information about the person being verified.

    """


    class MetaOapg:
        required = {
            "payer_id",
            "payee_id",
        }
        
        class properties:
            payee_id = schemas.UUIDSchema
            payer_id = schemas.UUIDSchema
            __annotations__ = {
                "payee_id": payee_id,
                "payer_id": payer_id,
            }
    
    payer_id: MetaOapg.properties.payer_id
    payee_id: MetaOapg.properties.payee_id
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payee_id"]) -> MetaOapg.properties.payee_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["payer_id"]) -> MetaOapg.properties.payer_id: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["payee_id", "payer_id", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payee_id"]) -> MetaOapg.properties.payee_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["payer_id"]) -> MetaOapg.properties.payer_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["payee_id", "payer_id", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        payer_id: typing.Union[MetaOapg.properties.payer_id, str, uuid.UUID, ],
        payee_id: typing.Union[MetaOapg.properties.payee_id, str, uuid.UUID, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'AdhocVerificationRequest':
        return super().__new__(
            cls,
            *_args,
            payer_id=payer_id,
            payee_id=payee_id,
            _configuration=_configuration,
            **kwargs,
        )
