# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.45.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class BaseCashPickup(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "amount",
            "account_id",
            "reference_id",
        }
        
        class properties:
            account_id = schemas.UUIDSchema
            amount = schemas.IntSchema
            reference_id = schemas.StrSchema
            business_id = schemas.UUIDSchema
            creation_time = schemas.DateTimeSchema
            
            
            class currency(
                schemas.StrSchema
            ):
                pass
            employee_customer_id = schemas.UUIDSchema
            id = schemas.UUIDSchema
            last_updated_time = schemas.DateTimeSchema
        
            @staticmethod
            def metadata() -> typing.Type['CashPickupMetadata']:
                return CashPickupMetadata
            pickup_time = schemas.DateTimeSchema
            posted_amount = schemas.IntSchema
            posted_date = schemas.DateSchema
            scheduled_pickup_date = schemas.DateSchema
            transaction_id = schemas.UUIDSchema
            __annotations__ = {
                "account_id": account_id,
                "amount": amount,
                "reference_id": reference_id,
                "business_id": business_id,
                "creation_time": creation_time,
                "currency": currency,
                "employee_customer_id": employee_customer_id,
                "id": id,
                "last_updated_time": last_updated_time,
                "metadata": metadata,
                "pickup_time": pickup_time,
                "posted_amount": posted_amount,
                "posted_date": posted_date,
                "scheduled_pickup_date": scheduled_pickup_date,
                "transaction_id": transaction_id,
            }
    
    amount: MetaOapg.properties.amount
    account_id: MetaOapg.properties.account_id
    reference_id: MetaOapg.properties.reference_id
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["account_id"]) -> MetaOapg.properties.account_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["reference_id"]) -> MetaOapg.properties.reference_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["business_id"]) -> MetaOapg.properties.business_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["creation_time"]) -> MetaOapg.properties.creation_time: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["currency"]) -> MetaOapg.properties.currency: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["employee_customer_id"]) -> MetaOapg.properties.employee_customer_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["last_updated_time"]) -> MetaOapg.properties.last_updated_time: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["metadata"]) -> 'CashPickupMetadata': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["pickup_time"]) -> MetaOapg.properties.pickup_time: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["posted_amount"]) -> MetaOapg.properties.posted_amount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["posted_date"]) -> MetaOapg.properties.posted_date: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["scheduled_pickup_date"]) -> MetaOapg.properties.scheduled_pickup_date: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["transaction_id"]) -> MetaOapg.properties.transaction_id: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["account_id", "amount", "reference_id", "business_id", "creation_time", "currency", "employee_customer_id", "id", "last_updated_time", "metadata", "pickup_time", "posted_amount", "posted_date", "scheduled_pickup_date", "transaction_id", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["account_id"]) -> MetaOapg.properties.account_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["reference_id"]) -> MetaOapg.properties.reference_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["business_id"]) -> typing.Union[MetaOapg.properties.business_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["creation_time"]) -> typing.Union[MetaOapg.properties.creation_time, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["currency"]) -> typing.Union[MetaOapg.properties.currency, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["employee_customer_id"]) -> typing.Union[MetaOapg.properties.employee_customer_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["last_updated_time"]) -> typing.Union[MetaOapg.properties.last_updated_time, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["metadata"]) -> typing.Union['CashPickupMetadata', schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["pickup_time"]) -> typing.Union[MetaOapg.properties.pickup_time, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["posted_amount"]) -> typing.Union[MetaOapg.properties.posted_amount, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["posted_date"]) -> typing.Union[MetaOapg.properties.posted_date, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["scheduled_pickup_date"]) -> typing.Union[MetaOapg.properties.scheduled_pickup_date, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["transaction_id"]) -> typing.Union[MetaOapg.properties.transaction_id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["account_id", "amount", "reference_id", "business_id", "creation_time", "currency", "employee_customer_id", "id", "last_updated_time", "metadata", "pickup_time", "posted_amount", "posted_date", "scheduled_pickup_date", "transaction_id", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        amount: typing.Union[MetaOapg.properties.amount, decimal.Decimal, int, ],
        account_id: typing.Union[MetaOapg.properties.account_id, str, uuid.UUID, ],
        reference_id: typing.Union[MetaOapg.properties.reference_id, str, ],
        business_id: typing.Union[MetaOapg.properties.business_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        creation_time: typing.Union[MetaOapg.properties.creation_time, str, datetime, schemas.Unset] = schemas.unset,
        currency: typing.Union[MetaOapg.properties.currency, str, schemas.Unset] = schemas.unset,
        employee_customer_id: typing.Union[MetaOapg.properties.employee_customer_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        last_updated_time: typing.Union[MetaOapg.properties.last_updated_time, str, datetime, schemas.Unset] = schemas.unset,
        metadata: typing.Union['CashPickupMetadata', schemas.Unset] = schemas.unset,
        pickup_time: typing.Union[MetaOapg.properties.pickup_time, str, datetime, schemas.Unset] = schemas.unset,
        posted_amount: typing.Union[MetaOapg.properties.posted_amount, decimal.Decimal, int, schemas.Unset] = schemas.unset,
        posted_date: typing.Union[MetaOapg.properties.posted_date, str, date, schemas.Unset] = schemas.unset,
        scheduled_pickup_date: typing.Union[MetaOapg.properties.scheduled_pickup_date, str, date, schemas.Unset] = schemas.unset,
        transaction_id: typing.Union[MetaOapg.properties.transaction_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'BaseCashPickup':
        return super().__new__(
            cls,
            *_args,
            amount=amount,
            account_id=account_id,
            reference_id=reference_id,
            business_id=business_id,
            creation_time=creation_time,
            currency=currency,
            employee_customer_id=employee_customer_id,
            id=id,
            last_updated_time=last_updated_time,
            metadata=metadata,
            pickup_time=pickup_time,
            posted_amount=posted_amount,
            posted_date=posted_date,
            scheduled_pickup_date=scheduled_pickup_date,
            transaction_id=transaction_id,
            _configuration=_configuration,
            **kwargs,
        )

from synctera_client.model.cash_pickup_metadata import CashPickupMetadata
