# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.45.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class Deposit(
    schemas.ComposedSchema,
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.

    Deposit using remote deposit capture
    """


    class MetaOapg:
        
        
        class all_of_1(
            schemas.DictSchema
        ):
        
        
            class MetaOapg:
                
                class properties:
                    creation_time = schemas.DateTimeSchema
                    date_captured = schemas.DateTimeSchema
                    date_processed = schemas.DateTimeSchema
                    deposit_amount = schemas.IntSchema
                    id = schemas.UUIDSchema
                    last_updated_time = schemas.DateTimeSchema
                    ocr_account_number = schemas.StrSchema
                    ocr_check_number = schemas.StrSchema
                    ocr_routing_number = schemas.StrSchema
                    
                    
                    class status(
                        schemas.EnumBase,
                        schemas.StrSchema
                    ):
                        
                        @schemas.classproperty
                        def SUBMITTED(cls):
                            return cls("SUBMITTED")
                        
                        @schemas.classproperty
                        def PENDING(cls):
                            return cls("PENDING")
                        
                        @schemas.classproperty
                        def FAILED(cls):
                            return cls("FAILED")
                        
                        @schemas.classproperty
                        def REJECTED(cls):
                            return cls("REJECTED")
                    transaction_id = schemas.UUIDSchema
                
                    @staticmethod
                    def vendor_info() -> typing.Type['VendorInfo']:
                        return VendorInfo
                    __annotations__ = {
                        "creation_time": creation_time,
                        "date_captured": date_captured,
                        "date_processed": date_processed,
                        "deposit_amount": deposit_amount,
                        "id": id,
                        "last_updated_time": last_updated_time,
                        "ocr_account_number": ocr_account_number,
                        "ocr_check_number": ocr_check_number,
                        "ocr_routing_number": ocr_routing_number,
                        "status": status,
                        "transaction_id": transaction_id,
                        "vendor_info": vendor_info,
                    }
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["creation_time"]) -> MetaOapg.properties.creation_time: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["date_captured"]) -> MetaOapg.properties.date_captured: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["date_processed"]) -> MetaOapg.properties.date_processed: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["deposit_amount"]) -> MetaOapg.properties.deposit_amount: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["last_updated_time"]) -> MetaOapg.properties.last_updated_time: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["ocr_account_number"]) -> MetaOapg.properties.ocr_account_number: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["ocr_check_number"]) -> MetaOapg.properties.ocr_check_number: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["ocr_routing_number"]) -> MetaOapg.properties.ocr_routing_number: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["status"]) -> MetaOapg.properties.status: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["transaction_id"]) -> MetaOapg.properties.transaction_id: ...
            
            @typing.overload
            def __getitem__(self, name: typing_extensions.Literal["vendor_info"]) -> 'VendorInfo': ...
            
            @typing.overload
            def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
            
            def __getitem__(self, name: typing.Union[typing_extensions.Literal["creation_time", "date_captured", "date_processed", "deposit_amount", "id", "last_updated_time", "ocr_account_number", "ocr_check_number", "ocr_routing_number", "status", "transaction_id", "vendor_info", ], str]):
                # dict_instance[name] accessor
                return super().__getitem__(name)
            
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["creation_time"]) -> typing.Union[MetaOapg.properties.creation_time, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["date_captured"]) -> typing.Union[MetaOapg.properties.date_captured, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["date_processed"]) -> typing.Union[MetaOapg.properties.date_processed, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["deposit_amount"]) -> typing.Union[MetaOapg.properties.deposit_amount, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["last_updated_time"]) -> typing.Union[MetaOapg.properties.last_updated_time, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["ocr_account_number"]) -> typing.Union[MetaOapg.properties.ocr_account_number, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["ocr_check_number"]) -> typing.Union[MetaOapg.properties.ocr_check_number, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["ocr_routing_number"]) -> typing.Union[MetaOapg.properties.ocr_routing_number, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["status"]) -> typing.Union[MetaOapg.properties.status, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["transaction_id"]) -> typing.Union[MetaOapg.properties.transaction_id, schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: typing_extensions.Literal["vendor_info"]) -> typing.Union['VendorInfo', schemas.Unset]: ...
            
            @typing.overload
            def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
            
            def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["creation_time", "date_captured", "date_processed", "deposit_amount", "id", "last_updated_time", "ocr_account_number", "ocr_check_number", "ocr_routing_number", "status", "transaction_id", "vendor_info", ], str]):
                return super().get_item_oapg(name)
            
        
            def __new__(
                cls,
                *_args: typing.Union[dict, frozendict.frozendict, ],
                creation_time: typing.Union[MetaOapg.properties.creation_time, str, datetime, schemas.Unset] = schemas.unset,
                date_captured: typing.Union[MetaOapg.properties.date_captured, str, datetime, schemas.Unset] = schemas.unset,
                date_processed: typing.Union[MetaOapg.properties.date_processed, str, datetime, schemas.Unset] = schemas.unset,
                deposit_amount: typing.Union[MetaOapg.properties.deposit_amount, decimal.Decimal, int, schemas.Unset] = schemas.unset,
                id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, schemas.Unset] = schemas.unset,
                last_updated_time: typing.Union[MetaOapg.properties.last_updated_time, str, datetime, schemas.Unset] = schemas.unset,
                ocr_account_number: typing.Union[MetaOapg.properties.ocr_account_number, str, schemas.Unset] = schemas.unset,
                ocr_check_number: typing.Union[MetaOapg.properties.ocr_check_number, str, schemas.Unset] = schemas.unset,
                ocr_routing_number: typing.Union[MetaOapg.properties.ocr_routing_number, str, schemas.Unset] = schemas.unset,
                status: typing.Union[MetaOapg.properties.status, str, schemas.Unset] = schemas.unset,
                transaction_id: typing.Union[MetaOapg.properties.transaction_id, str, uuid.UUID, schemas.Unset] = schemas.unset,
                vendor_info: typing.Union['VendorInfo', schemas.Unset] = schemas.unset,
                _configuration: typing.Optional[schemas.Configuration] = None,
                **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
            ) -> 'all_of_1':
                return super().__new__(
                    cls,
                    *_args,
                    creation_time=creation_time,
                    date_captured=date_captured,
                    date_processed=date_processed,
                    deposit_amount=deposit_amount,
                    id=id,
                    last_updated_time=last_updated_time,
                    ocr_account_number=ocr_account_number,
                    ocr_check_number=ocr_check_number,
                    ocr_routing_number=ocr_routing_number,
                    status=status,
                    transaction_id=transaction_id,
                    vendor_info=vendor_info,
                    _configuration=_configuration,
                    **kwargs,
                )
        
        @classmethod
        @functools.lru_cache()
        def all_of(cls):
            # we need this here to make our import statements work
            # we must store _composed_schemas in here so the code is only run
            # when we invoke this method. If we kept this at the class
            # level we would get an error because the class level
            # code would be run when this module is imported, and these composed
            # classes don't exist yet because their module has not finished
            # loading
            return [
                DepositRequest,
                cls.all_of_1,
            ]


    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, bool, None, list, tuple, bytes, io.FileIO, io.BufferedReader, ],
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Deposit':
        return super().__new__(
            cls,
            *_args,
            _configuration=_configuration,
            **kwargs,
        )

from synctera_client.model.deposit_request import DepositRequest
from synctera_client.model.vendor_info import VendorInfo
