# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>  # noqa: E501

    The version of the OpenAPI document: 0.45.0
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class Fee(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "amount",
            "product_type",
            "currency",
            "fee_type",
        }
        
        class properties:
            amount = schemas.Int64Schema
            
            
            class currency(
                schemas.StrSchema
            ):
                pass
            
            
            class fee_type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
                
                @schemas.classproperty
                def MONTHLY_FEE(cls):
                    return cls("MONTHLY_FEE")
                
                @schemas.classproperty
                def ANNUAL_FEE(cls):
                    return cls("ANNUAL_FEE")
                
                @schemas.classproperty
                def ATM_WITHDRWAL_FEE(cls):
                    return cls("ATM_WITHDRWAL_FEE")
                
                @schemas.classproperty
                def OVERDRAFT_FEE(cls):
                    return cls("OVERDRAFT_FEE")
                
                @schemas.classproperty
                def ACH_FEE(cls):
                    return cls("ACH_FEE")
                
                @schemas.classproperty
                def WIRE_FEE(cls):
                    return cls("WIRE_FEE")
            
            
            class product_type(
                schemas.EnumBase,
                schemas.StrSchema
            ):
                
                @schemas.classproperty
                def INTEREST(cls):
                    return cls("INTEREST")
                
                @schemas.classproperty
                def FEE(cls):
                    return cls("FEE")
            id = schemas.UUIDSchema
            __annotations__ = {
                "amount": amount,
                "currency": currency,
                "fee_type": fee_type,
                "product_type": product_type,
                "id": id,
            }
    
    amount: MetaOapg.properties.amount
    product_type: MetaOapg.properties.product_type
    currency: MetaOapg.properties.currency
    fee_type: MetaOapg.properties.fee_type
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["currency"]) -> MetaOapg.properties.currency: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["fee_type"]) -> MetaOapg.properties.fee_type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["product_type"]) -> MetaOapg.properties.product_type: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["id"]) -> MetaOapg.properties.id: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["amount", "currency", "fee_type", "product_type", "id", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["amount"]) -> MetaOapg.properties.amount: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["currency"]) -> MetaOapg.properties.currency: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["fee_type"]) -> MetaOapg.properties.fee_type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["product_type"]) -> MetaOapg.properties.product_type: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["id"]) -> typing.Union[MetaOapg.properties.id, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["amount", "currency", "fee_type", "product_type", "id", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        amount: typing.Union[MetaOapg.properties.amount, decimal.Decimal, int, ],
        product_type: typing.Union[MetaOapg.properties.product_type, str, ],
        currency: typing.Union[MetaOapg.properties.currency, str, ],
        fee_type: typing.Union[MetaOapg.properties.fee_type, str, ],
        id: typing.Union[MetaOapg.properties.id, str, uuid.UUID, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Fee':
        return super().__new__(
            cls,
            *_args,
            amount=amount,
            product_type=product_type,
            currency=currency,
            fee_type=fee_type,
            id=id,
            _configuration=_configuration,
            **kwargs,
        )
