# coding: utf-8

"""
    Synctera API

    <h2>Let's build something great.</h2><p>Welcome to the official reference documentation for Synctera APIs. Our APIs are the best way to automate your company's banking needs and are designed to be easy to understand and implement.</p><p>We're continuously growing this library and what you see here is just the start, but if you need something specific or have a question, <a class='text-blue-600' href='https://synctera.com/contact' target='_blank' rel='noreferrer'>contact us</a>.</p>   # noqa: E501

    The version of the OpenAPI document: 0.32.0.dev6
    Generated by: https://openapi-generator.tech
"""

from datetime import date, datetime  # noqa: F401
import decimal  # noqa: F401
import functools  # noqa: F401
import io  # noqa: F401
import re  # noqa: F401
import typing  # noqa: F401
import typing_extensions  # noqa: F401
import uuid  # noqa: F401

import frozendict  # noqa: F401

from synctera_client import schemas  # noqa: F401


class Workspace(
    schemas.DictSchema
):
    """NOTE: This class is auto generated by OpenAPI Generator.
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """


    class MetaOapg:
        required = {
            "environment",
            "partner_id",
            "bank_id",
            "partner_name",
            "bank_name",
            "rank",
            "verification_status",
        }
        
        class properties:
            bank_id = schemas.IntSchema
            bank_name = schemas.StrSchema
        
            @staticmethod
            def environment() -> typing.Type['Environment']:
                return Environment
            partner_id = schemas.IntSchema
            partner_name = schemas.StrSchema
            rank = schemas.IntSchema
            
            
            class verification_status(
                schemas.EnumBase,
                schemas.StrSchema
            ):
            
            
                class MetaOapg:
                    enum_value_to_name = {
                        "UNVERIFIED": "UNVERIFIED",
                        "PENDING": "PENDING",
                        "PROVISIONAL": "PROVISIONAL",
                        "ACCEPTED": "ACCEPTED",
                        "REVIEW": "REVIEW",
                        "REJECTED": "REJECTED",
                    }
                
                @schemas.classproperty
                def UNVERIFIED(cls):
                    return cls("UNVERIFIED")
                
                @schemas.classproperty
                def PENDING(cls):
                    return cls("PENDING")
                
                @schemas.classproperty
                def PROVISIONAL(cls):
                    return cls("PROVISIONAL")
                
                @schemas.classproperty
                def ACCEPTED(cls):
                    return cls("ACCEPTED")
                
                @schemas.classproperty
                def REVIEW(cls):
                    return cls("REVIEW")
                
                @schemas.classproperty
                def REJECTED(cls):
                    return cls("REJECTED")
            tenant = schemas.StrSchema
            __annotations__ = {
                "bank_id": bank_id,
                "bank_name": bank_name,
                "environment": environment,
                "partner_id": partner_id,
                "partner_name": partner_name,
                "rank": rank,
                "verification_status": verification_status,
                "tenant": tenant,
            }
    
    environment: 'Environment'
    partner_id: MetaOapg.properties.partner_id
    bank_id: MetaOapg.properties.bank_id
    partner_name: MetaOapg.properties.partner_name
    bank_name: MetaOapg.properties.bank_name
    rank: MetaOapg.properties.rank
    verification_status: MetaOapg.properties.verification_status
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bank_id"]) -> MetaOapg.properties.bank_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["bank_name"]) -> MetaOapg.properties.bank_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["environment"]) -> 'Environment': ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["partner_id"]) -> MetaOapg.properties.partner_id: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["partner_name"]) -> MetaOapg.properties.partner_name: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["rank"]) -> MetaOapg.properties.rank: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["verification_status"]) -> MetaOapg.properties.verification_status: ...
    
    @typing.overload
    def __getitem__(self, name: typing_extensions.Literal["tenant"]) -> MetaOapg.properties.tenant: ...
    
    @typing.overload
    def __getitem__(self, name: str) -> schemas.UnsetAnyTypeSchema: ...
    
    def __getitem__(self, name: typing.Union[typing_extensions.Literal["bank_id", "bank_name", "environment", "partner_id", "partner_name", "rank", "verification_status", "tenant", ], str]):
        # dict_instance[name] accessor
        return super().__getitem__(name)
    
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bank_id"]) -> MetaOapg.properties.bank_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["bank_name"]) -> MetaOapg.properties.bank_name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["environment"]) -> 'Environment': ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["partner_id"]) -> MetaOapg.properties.partner_id: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["partner_name"]) -> MetaOapg.properties.partner_name: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["rank"]) -> MetaOapg.properties.rank: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["verification_status"]) -> MetaOapg.properties.verification_status: ...
    
    @typing.overload
    def get_item_oapg(self, name: typing_extensions.Literal["tenant"]) -> typing.Union[MetaOapg.properties.tenant, schemas.Unset]: ...
    
    @typing.overload
    def get_item_oapg(self, name: str) -> typing.Union[schemas.UnsetAnyTypeSchema, schemas.Unset]: ...
    
    def get_item_oapg(self, name: typing.Union[typing_extensions.Literal["bank_id", "bank_name", "environment", "partner_id", "partner_name", "rank", "verification_status", "tenant", ], str]):
        return super().get_item_oapg(name)
    

    def __new__(
        cls,
        *_args: typing.Union[dict, frozendict.frozendict, ],
        environment: 'Environment',
        partner_id: typing.Union[MetaOapg.properties.partner_id, decimal.Decimal, int, ],
        bank_id: typing.Union[MetaOapg.properties.bank_id, decimal.Decimal, int, ],
        partner_name: typing.Union[MetaOapg.properties.partner_name, str, ],
        bank_name: typing.Union[MetaOapg.properties.bank_name, str, ],
        rank: typing.Union[MetaOapg.properties.rank, decimal.Decimal, int, ],
        verification_status: typing.Union[MetaOapg.properties.verification_status, str, ],
        tenant: typing.Union[MetaOapg.properties.tenant, str, schemas.Unset] = schemas.unset,
        _configuration: typing.Optional[schemas.Configuration] = None,
        **kwargs: typing.Union[schemas.AnyTypeSchema, dict, frozendict.frozendict, str, date, datetime, uuid.UUID, int, float, decimal.Decimal, None, list, tuple, bytes],
    ) -> 'Workspace':
        return super().__new__(
            cls,
            *_args,
            environment=environment,
            partner_id=partner_id,
            bank_id=bank_id,
            partner_name=partner_name,
            bank_name=bank_name,
            rank=rank,
            verification_status=verification_status,
            tenant=tenant,
            _configuration=_configuration,
            **kwargs,
        )

from synctera_client.model.environment import Environment
